/*
* Math library
*
* Copyright (C) 2016 Intel Corporation. All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions
* are met:
*
*   * Redistributions of source code must retain the above copyright
*     notice, this list of conditions and the following disclaimer.
*   * Redistributions in binary form must reproduce the above copyright
*     notice, this list of conditions and the following disclaimer in
*     the documentation and/or other materials provided with the
*     distribution.
*   * Neither the name of Intel Corporation nor the names of its
*     contributors may be used to endorse or promote products derived
*     from this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
* "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
* LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
* A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
* OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
* LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
* THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
* OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
*
* Author Name <jingwei.zhang@intel.com>
*   History:
*   03-14-2016 Initial version. numerics svn rev. 12864
*/
	.file "logf_table.c"
	.section .rodata, "a"
	.align 16
	.align 16
	.hidden __libm_logf_table_256
	.globl __libm_logf_table_256
__libm_logf_table_256:
	.long	0x55d5889e,0x3f600401
	.long	0x14586b54,0x3f781212
	.long	0xf96832f0,0x3f841929
	.long	0x84c75f07,0x3f8c3173
	.long	0x1ac73386,0x3f91a6b9
	.long	0x5d9ac03a,0x3f95ba9a
	.long	0x074325f4,0x3f99d2a8
	.long	0x25979802,0x3f9d6b27
	.long	0xa19dfaa9,0x3fa0c58f
	.long	0x78cbce1b,0x3fa2954c
	.long	0x2da96c57,0x3fa4a94d
	.long	0xf2d4bb58,0x3fa67c94
	.long	0xb630f068,0x3fa85188
	.long	0xbe73af4c,0x3faa6b8a
	.long	0x06f72a9e,0x3fac441e
	.long	0x13606d07,0x3fae1e67
	.long	0x11ab9301,0x3faffa69
	.long	0x9c5da601,0x3fb0ec13
	.long	0x643d190b,0x3fb1dbd2
	.long	0x84fe5f1c,0x3fb2cc72
	.long	0xa7d1ee64,0x3fb3bdf5
	.long	0x7aa012e0,0x3fb4b05d
	.long	0x7ceb5702,0x3fb580db
	.long	0x89365a7a,0x3fb674f0
	.long	0x2c6b568d,0x3fb769ef
	.long	0x27506a48,0x3fb85fd9
	.long	0x5d594989,0x3fb9335e
	.long	0x20c8e5f5,0x3fba2b02
	.long	0xac1a86ac,0x3fbb0004
	.long	0x769fca11,0x3fbbf968
	.long	0xbfee13a8,0x3fbccfed
	.long	0x638446a2,0x3fbda727
	.long	0x7fe10f7a,0x3fbea325
	.long	0xfedbfde6,0x3fbf7be9
	.long	0x52ff25f4,0x3fc02ab3
	.long	0x579d204d,0x3fc097ce
	.long	0x8227e47c,0x3fc1178e
	.long	0x7dbecf34,0x3fc18574
	.long	0x25f25d41,0x3fc1f3b9
	.long	0x1e6ddf57,0x3fc2625d
	.long	0x0c86813a,0x3fc2d161
	.long	0x9741142e,0x3fc340c5
	.long	0x6757f2a9,0x3fc3b08b
	.long	0x08378004,0x3fc40dfb
	.long	0xe8ca5f7c,0x3fc47e74
	.long	0xf6466de4,0x3fc4ef51
	.long	0xe02ba516,0x3fc56092
	.long	0x57cd74d5,0x3fc5d238
	.long	0x37335d76,0x3fc6313a
	.long	0xdabbd383,0x3fc6a399
	.long	0xdd3ce41a,0x3fc70337
	.long	0x128f6127,0x3fc77654
	.long	0x2a0b022d,0x3fc7e9d8
	.long	0x759f512f,0x3fc84a6b
	.long	0xd5f5a310,0x3fc8ab47
	.long	0x9096581b,0x3fc91fe4
	.long	0x4011aa76,0x3fc98163
	.long	0x07089664,0x3fc9f6c4
	.long	0x29348f43,0x3fca58e7
	.long	0xc31693ad,0x3fcabb55
	.long	0x4919efd0,0x3fcb1e10
	.long	0x93e367cb,0x3fcb94ee
	.long	0xc067555f,0x3fcbf851
	.long	0x54bf23a6,0x3fcc5c02
	.long	0xc9db3c52,0x3fccc000
	.long	0x99c85674,0x3fcd244d
	.long	0x3fb2f450,0x3fcd88e9
	.long	0x37eaef01,0x3fcdedd4
	.long	0xffe71012,0x3fce530e
	.long	0x1648b971,0x3fceb89a
	.long	0xfadf9bde,0x3fcf1e75
	.long	0x2ead7c36,0x3fcf84a3
	.long	0x33ea07cd,0x3fcfeb22
	.long	0xc7035c1c,0x3fd028f9
	.long	0xe0d9635a,0x3fd05c8b
	.long	0x8f8ae797,0x3fd085eb
	.long	0xe32d1911,0x3fd0b9c8
	.long	0x60b78081,0x3fd0edd0
	.long	0x4cf0063f,0x3fd12202
	.long	0x927aecd4,0x3fd14be2
	.long	0x8ef18adf,0x3fd18061
	.long	0xbe2fc63b,0x3fd1b50b
	.long	0xc7cf242d,0x3fd1df4c
	.long	0x6d0eb8d4,0x3fd21445
	.long	0x991eba49,0x3fd23ec5
	.long	0x9f870afb,0x3fd2740d
	.long	0xabcdfa04,0x3fd29ecd
	.long	0x02adccee,0x3fd2d466
	.long	0xb04ea9d4,0x3fd2ff66
	.long	0x4b355a38,0x3fd33550
	.long	0x5ec44f5d,0x3fd36092
	.long	0xc3337e75,0x3fd38bf1
	.long	0x77333184,0x3fd3c252
	.long	0x63c1683e,0x3fd3edf4
	.long	0x23d5e8c7,0x3fd419b4
	.long	0xe0539f49,0x3fd44591
	.long	0x75b6f0ad,0x3fd47c91
	.long	0x41552b09,0x3fd4a8b3
	.long	0x908901a0,0x3fd4d4f3
	.long	0x8da1f968,0x3fd50152
	.long	0x6347d4f6,0x3fd52dd0
	.long	0x3c7b8a8a,0x3fd55a6d
	.long	0x2b112a59,0x3fd5925d
	.long	0x6b543db2,0x3fd5bf40
	.long	0x3d5c35ae,0x3fd5ec43
	.long	0xcdb02c1f,0x3fd61965
	.long	0x4935b2a2,0x3fd646a8
	.long	0xdd31de95,0x3fd6740a
	.long	0xb74a58c5,0x3fd6a18d
	.long	0x058670ec,0x3fd6cf31
	.long	0xe852f0ba,0x3fd6f180
	.long	0x71b894f0,0x3fd71f5d
	.long	0xefd66d5c,0x3fd74d5a
	.long	0x922bd37e,0x3fd77b79
	.long	0x889f19e2,0x3fd7a9b9
	.long	0x037eb6a6,0x3fd7d81b
	.long	0x33827231,0x3fd8069e
	.long	0xd3ef8bcb,0x3fd82996
	.long	0x776dcbfb,0x3fd85855
	.long	0x58327ccf,0x3fd88736
	.long	0x973ab8cf,0x3fd8aa75
	.long	0xdc8824e5,0x3fd8d992
	.long	0xea7d9512,0x3fd908d2
	.long	0xe79c0e56,0x3fd92c59
	.long	0x50ee3ed3,0x3fd95bd7
	.long	0x11a3ee5b,0x3fd98b78
	.long	0xf33d406c,0x3fd9af47
	.long	0x0c1914a8,0x3fd9df27
	.long	0xed14fda5,0x3fda0325
	.long	0x0224fa79,0x3fda3344
	.long	0x5e80c383,0x3fda5772
	.long	0x165dd199,0x3fda87d0
	.long	0x6c03f896,0x3fdaac2e
	.long	0x6fdf6a81,0x3fdadccc
	.long	0x3eb1e790,0x3fdb015b
	.long	0x3a635948,0x3fdb323a
	.long	0x04462909,0x3fdb56fa
	.long	0xa659bc93,0x3fdb881a
	.long	0xef3db165,0x3fdbad0b
	.long	0x97781c2f,0x3fdbd212
	.long	0x36f08819,0x3fdc0392
	.long	0x1e4d32fd,0x3fdc28cb
	.long	0xb84723c2,0x3fdc4e19
	.long	0xc74554c9,0x3fdc7ff9
	.long	0x64e9db05,0x3fdca57b
	.long	0x0a5cebb0,0x3fdccb13
	.long	0xd18f326f,0x3fdcf0c0
	.long	0x75b5a201,0x3fdd2320
	.long	0x46defa6b,0x3fdd4902
	.long	0x918d25cd,0x3fdd6efa
	.long	0x707ae52f,0x3fdd9509
	.long	0xfe92c554,0x3fddbb2e
	.long	0x3445e4af,0x3fddee2f
	.long	0x1a2726ce,0x3fde148a
	.long	0x0a49ff40,0x3fde3afc
	.long	0x206d516e,0x3fde6185
	.long	0x78823d52,0x3fde8825
	.long	0x2eac990c,0x3fdeaedd
	.long	0x5f436be3,0x3fded5ac
	.long	0x26d16ab9,0x3fdefc93
	.long	0xa2157600,0x3fdf2391
	.long	0xee03192d,0x3fdf4aa7
	.long	0x27c30bb0,0x3fdf71d6
	.long	0x6cb3b379,0x3fdf991c
	.long	0xda69a910,0x3fdfc07a
	.long	0x8eb03d3e,0x3fdfe7f1
	.long	0x53c5002e,0x3fe007c0
	.long	0x2198a5a1,0x3fe01b94
	.long	0x400c64eb,0x3fe02f74
	.long	0xbe7603ad,0x3fe04360
	.long	0xac47fe34,0x3fe05759
	.long	0x1911cf52,0x3fe06b5f
	.long	0x0533c568,0x3fe078bf
	.long	0x687e7b0e,0x3fe08cd9
	.long	0x74cf9019,0x3fe0a100
	.long	0x3a234477,0x3fe0b534
	.long	0xc89431ce,0x3fe0c974
	.long	0x305b9886,0x3fe0ddc2
	.long	0x4bafc918,0x3fe0eb52
	.long	0x4213a476,0x3fe0ffb5
	.long	0x3da97d9f,0x3fe11425
	.long	0x4f1d9aff,0x3fe128a2
	.long	0x52bf0865,0x3fe13652
	.long	0x58b4a92d,0x3fe14ae5
	.long	0xa19c765b,0x3fe15f85
	.long	0x38c119fa,0x3fe16d4d
	.long	0xc20dd133,0x3fe18203
	.long	0xbc4b1f3b,0x3fe196c7
	.long	0x38b7a33c,0x3fe1a4a7
	.long	0xc0c9653d,0x3fe1b981
	.long	0xe8bb106b,0x3fe1ce69
	.long	0x9de06944,0x3fe1dc61
	.long	0xa2ad0da4,0x3fe1f160
	.long	0x7740737e,0x3fe2066d
	.long	0xba47a394,0x3fe2147d
	.long	0xbc5ebac3,0x3fe229a1
	.long	0x841a502e,0x3fe237c1
	.long	0xe6f80d9a,0x3fe24cfc
	.long	0x55cd5762,0x3fe25b2c
	.long	0x4d5f7c41,0x3fe2707f
	.long	0x842ca384,0x3fe285e0
	.long	0x4708b773,0x3fe29429
	.long	0x670aff0c,0x3fe2a9a2
	.long	0x2c8d1cc1,0x3fe2b7fb
	.long	0x6395f5f5,0x3fe2c65a
	.long	0x57b0df43,0x3fe2dbf5
	.long	0xc3f97655,0x3fe2ea64
	.long	0x23684d73,0x3fe30018
	.long	0xe9a8b5cd,0x3fe30e97
	.long	0xebdd34ea,0x3fe32463
	.long	0x314ad796,0x3fe332f4
	.long	0x0e7464d0,0x3fe348d9
	.long	0xf8c43d6e,0x3fe35779
	.long	0x961a6a99,0x3fe36621
	.long	0x9f3c366a,0x3fe37c29
	.long	0x171976e7,0x3fe38ae2
	.long	0x57a603e7,0x3fe399a1
	.long	0xfe77b9d1,0x3fe3afcc
	.long	0x503533b5,0x3fe3be9d
	.long	0x80b4a8a3,0x3fe3cd74
	.long	0x3918f76c,0x3fe3e3c4
	.long	0xb27ed6c7,0x3fe3f2ac
	.long	0x2125ca93,0x3fe4019c
	.long	0x61389722,0x3fe41810
	.long	0x518df545,0x3fe42711
	.long	0x4e12b6bf,0x3fe43619
	.long	0x5d68ea69,0x3fe44528
	.long	0x464c893a,0x3fe45bcc
	.long	0x21f117fc,0x3fe46aed
	.long	0x27e8a2d3,0x3fe47a15
	.long	0x5efffccc,0x3fe48944
	.long	0xbcb69835,0x3fe4a018
	.long	0x0c9d65d7,0x3fe4af5a
	.long	0xa5bdbe87,0x3fe4bea2
	.long	0x8f10ac47,0x3fe4cdf2
	.long	0xcf994058,0x3fe4dd49
	.long	0x6e64a684,0x3fe4eca8
	.long	0x3cd8eb68,0x3fe503c4
	.long	0x6667fc57,0x3fe51335
	.long	0x0738a3d8,0x3fe522ae
	.long	0x26867857,0x3fe5322e
	.long	0xcb979809,0x3fe541b5
	.long	0xfdbcbd62,0x3fe55144
	.long	0xc45153c7,0x3fe560db
	.long	0x26bb8c66,0x3fe5707a
	.long	0x0ed5b900,0x3fe587f6
	.long	0x977c8f31,0x3fe597a7
	.long	0xd634bb8b,0x3fe5a760
	.long	0xd295f10f,0x3fe5b721
	.long	0x94431ef9,0x3fe5c6ea
	.long	0x22ea86f6,0x3fe5d6bb
	.long	0x8645d390,0x3fe5e693
	.long	0xc61a2ed2,0x3fe5f673
	.long	0xea385926,0x3fe6065b
	.long	0xfa7cc06b,0x3fe6164b
	.long	0xfecf9743,0x3fe62643
	.type	__libm_logf_table_256,@object
	.size	__libm_logf_table_256,2048
	.data
	.section .note.GNU-stack, ""
# End
